var isPrime = function(number) {
  if(number === 1) return false;

  for(var i = 2; i < number; i++) {
    if(number % i === 0)
      return false;
  }
  return true;
}

var countPrimesAsync = function(number, callback) {
  var countPrimes = function(number) {
    var count = 0;
    for(var i = 1; i <= number; i++) {
      if(isPrime(i))
        count++;
    }           

    return count;
  }

  return new Promise(function(resolve, reject) {
    if(number > 0) {
      resolve(countPrimes(number));
      console.log("Promise resolved");
    }
    else {
      reject("invalid input"); //or throw "invalid input";
      console.log("Promise rejected");
    }
  });
}

var reportPrimes = function(number) {
  var promise = countPrimesAsync(number);
  
  console.log("Sign up with the promise to process reject or fulfillment");
  promise
    .then(function(count) {
      console.log("number of primes within " + number + " is " + count);
    })
    .catch(function(err) {
      console.log("for " + number + " - " + err);      
    });
}

reportPrimes(250000);
reportPrimes(-1);
